"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useKeyInput;
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/toConsumableArray"));
function useKeyInput(_ref) {
  var _ref$defaultAll = _ref.defaultAll,
    defaultAll = _ref$defaultAll === void 0 ? true : _ref$defaultAll,
    disabled = _ref.disabled,
    keySet = _ref.keySet,
    keydown = _ref.keydown,
    keyup = _ref.keyup;
  var debug = function debug(test, str) {
    var _console;
    return (_console = console).log.apply(_console, [str].concat((0, _toConsumableArray2.default)([test] || [])));
  };
  var subObj = function subObj(e, keyObj) {
    if (typeof keyObj === 'function' && e.type === 'keydown') keyObj(e);else if (!keyObj.disabled) {
      if ((keyObj === null || keyObj === void 0 ? void 0 : keyObj.default) === false) e.preventDefault();
      if (keyObj[e.type]) keyObj[e.type](e);
    }
  };
  var handleKey = function handleKey(e) {
    if (!defaultAll) e.preventDefault();
    var keyObj = keySet[e.keyCode.toString()];
    e.debug = function (test) {
      return debug(test, e.type + ': ' + e.key);
    };
    if (keyObj) subObj(e, keyObj);else if (keySet.other) subObj(e, keySet.other);
  };
  return function (e) {
    return !disabled ? keydown || keyup ? {
      keydown: keydown,
      keyup: keyup
    }[e.type] ? handleKey(e) : {} : handleKey(e) : {};
  };
}
;