"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useTimeout;
var _react = require("react");
function useTimeout() {
  var toDo = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
  var wait = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 3000;
  (0, _react.useEffect)(function () {
    var timer = setTimeout(function () {
      toDo();
    }, wait);
    return function () {
      return clearTimeout(timer);
    };
  });
}
;