"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useBusy;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/slicedToArray"));
var _react = require("react");
var _lal = require("lal");
function useBusy(props) {
  var _uno = (0, _lal.uno)(props),
    disable = _uno.disable,
    _uno$onRest = _uno.onRest,
    _onRest = _uno$onRest === void 0 ? function () {} : _uno$onRest,
    _uno$onStart = _uno.onStart,
    _onStart = _uno$onStart === void 0 ? function () {} : _uno$onStart;
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    busy = _useState2[0],
    setBusy = _useState2[1];
  return [busy, {
    onStart: function onStart(result, spring, item) {
      if (!disable) {
        setBusy(true);
        _onStart(true, item);
      }
    },
    onRest: function onRest(result, spring, item) {
      if (!disable) {
        setBusy(false);
        _onRest(true, item);
      }
    }
  }, setBusy];
}
;