"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useInput;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/slicedToArray"));
var _react = require("react");
var b = function b() {};
function useInput(_ref) {
  var _ref$close = _ref.close,
    close = _ref$close === void 0 ? b : _ref$close,
    _ref$click = _ref.click,
    click = _ref$click === void 0 ? b : _ref$click,
    _ref$during = _ref.during,
    during = _ref$during === void 0 ? b : _ref$during,
    debug = _ref.debug,
    hostid = _ref.hostid,
    _ref$onBlur = _ref.onBlur,
    _onBlur = _ref$onBlur === void 0 ? b : _ref$onBlur,
    _ref$onFocus = _ref.onFocus,
    _onFocus = _ref$onFocus === void 0 ? b : _ref$onFocus;
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    focus = _useState2[0],
    setFocus = _useState2[1];
  return {
    events: {
      onBlur: function onBlur(e) {
        var _e$relatedTarget, _e$relatedTarget$attr, _e$relatedTarget$attr2;
        _onBlur(e);
        var targetID = e === null || e === void 0 ? void 0 : (_e$relatedTarget = e.relatedTarget) === null || _e$relatedTarget === void 0 ? void 0 : (_e$relatedTarget$attr = _e$relatedTarget.attributes) === null || _e$relatedTarget$attr === void 0 ? void 0 : (_e$relatedTarget$attr2 = _e$relatedTarget$attr.hostid) === null || _e$relatedTarget$attr2 === void 0 ? void 0 : _e$relatedTarget$attr2.value;
        if (debug) console.log({
          location: 'stuff useInput onBlur',
          targetID: targetID,
          hostid: hostid
        });
        if (!hostid) setFocus(false);else if (targetID !== hostid) {
          setFocus(false);
          close(targetID);
        }
      },
      onClick: function onClick(e) {
        if (debug) console.log({
          location: 'stuff useInput onClick',
          e: e
        });
        click(e);
      },
      onFocus: function onFocus(e) {
        _onFocus(e);
        if (debug) console.log({
          location: 'stuff useInput onFocus',
          e: e
        });
        setFocus(true);
        during(e);
      }
    },
    focus: focus,
    setFocus: setFocus
  };
}
;