"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useRendered;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/slicedToArray"));
var _react = require("react");
function useRendered() {
  var onRendered = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    rendered = _useState2[0],
    setRendered = _useState2[1];
  (0, _react.useEffect)(function () {
    if (!rendered) {
      onRendered(1);
      setRendered(true);
    }
  }, [onRendered, rendered]);
  return [rendered, setRendered];
}
;